// Generated by CoffeeScript 1.12.2
(function() {
  var config, crypto, digest;

  crypto = require('crypto');

  config = require('./config');

  digest = function(message, key) {
    return crypto.createHmac("sha256", new Buffer(key, "hex")).update(message).digest('hex');
  };

  exports.generateAkamaiToken = function(options) {
    var auth, expiration, key, ref, ref1, ref2, start, tokenName, tokenParts;
    key = (ref = options.key) != null ? ref : config().akamai_key;
    tokenName = (ref1 = options.tokenName) != null ? ref1 : "__cld_token__";
    expiration = options.end_time;
    if (expiration == null) {
      if (options.window == null) {
        start = (ref2 = options.start_time) != null ? ref2 : new Date();
        expiration = start + window;
      } else {
        throw "Must provide either end_time or window";
      }
    }
    tokenParts = [];
    if (options.ip != null) {
      tokenParts.push("ip=" + options.ip);
    }
    if (options.start_time != null) {
      tokenParts.push("st=" + options.start_time);
    }
    tokenParts.push("exp=" + expiration);
    tokenParts.push("acl=" + options.acl);
    auth = digest(tokenParts.join("~"), key);
    tokenParts.push("hmac=" + auth);
    return tokenName + "=" + (tokenParts.join('~'));
  };

}).call(this);

//# sourceMappingURL=akamai.js.map
